blob: 2517450656cb912e9771e098776bd45ceb39edbb [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Orion Hodson64fe3be2018-06-15 12:50:22 +010044export JAVAC="javac -g -Xlint:-options -source 1.8 -target 1.8"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Alan Leungcf2de162018-03-30 20:18:20 +000048export USE_D8="true"
Igor Murashkin2a337752017-06-16 14:34:40 +000049export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070050export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070051
Alan Leungd5cbc562018-03-15 14:02:46 -070052# If d8 was not set by the environment variable, assume it is in the path.
53if [ -z "$D8" ]; then
54 export D8="d8"
55fi
56
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070057# If dx was not set by the environment variable, assume it is in the path.
58if [ -z "$DX" ]; then
Orion Hodson64fe3be2018-06-15 12:50:22 +010059 export DX="d8-compat-dx"
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070060fi
61
Orion Hodson64fe3be2018-06-15 12:50:22 +010062export DEXMERGER="$D8"
Alan Leungd5cbc562018-03-15 14:02:46 -070063
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080064# If jasmin was not set by the environment variable, assume it is in the path.
65if [ -z "$JASMIN" ]; then
66 export JASMIN="jasmin"
67fi
68
Andreas Gampe8fda9f22014-10-03 16:15:37 -070069# If smali was not set by the environment variable, assume it is in the path.
70if [ -z "$SMALI" ]; then
71 export SMALI="smali"
72fi
73
Sebastien Hertz19ac0272015-02-24 17:39:50 +010074# ANDROID_BUILD_TOP is not set in a build environment.
75if [ -z "$ANDROID_BUILD_TOP" ]; then
76 export ANDROID_BUILD_TOP=$oldwd
77fi
78
Dan Willemsen12371e92017-03-06 17:55:20 -080079# OUT_DIR defaults to out, and may be relative to $ANDROID_BUILD_TOP.
80# Convert it to an absolute path, since we cd into the tmp_dir to run the tests.
81export OUT_DIR=${OUT_DIR:-out}
82if [[ "$OUT_DIR" != /* ]]; then
83 export OUT_DIR=$ANDROID_BUILD_TOP/$OUT_DIR
84fi
85
Andreas Gampef47fb2f2016-06-24 22:30:29 -070086# ANDROID_HOST_OUT is not set in a build environment.
87if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsen12371e92017-03-06 17:55:20 -080088 export ANDROID_HOST_OUT=${OUT_DIR}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070089fi
90
Igor Murashkine5181932017-06-15 16:03:50 -070091# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070092if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070093 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
94fi
95
Igor Murashkin271a0f82017-02-14 21:14:17 +000096# Zipalign is not on the PATH in some configs, auto-detect it.
97if [ -z "$ZIPALIGN" ]; then
98 if which zipalign >/dev/null; then
99 ZIPALIGN="zipalign";
100 else
101 # TODO: Add a dependency for zipalign in Android.run-test.mk
102 # once it doesn't depend on libandroidfw (b/35246701)
103 case "$OSTYPE" in
104 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
105 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
106 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
107 esac
108 fi
109fi
110export ZIPALIGN
111
David Brazdil122c6632018-01-24 17:32:49 +0000112# If hiddenapi was not set by the environment variable, assume it is in
113# ANDROID_HOST_OUT.
David Brazdil11b67b22018-01-18 16:41:40 +0000114if [ -z "$HIDDENAPI" ]; then
David Brazdil122c6632018-01-24 17:32:49 +0000115 export HIDDENAPI="${ANDROID_HOST_OUT}/bin/hiddenapi"
David Brazdil11b67b22018-01-18 16:41:40 +0000116fi
117
Roland Levillain76cfe612017-10-30 13:14:28 +0000118chroot=
119
jeffhao5d1ac922011-09-29 17:41:15 -0700120info="info.txt"
121build="build"
122run="run"
123expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700124check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700125output="output.txt"
126build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100127cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700128strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700129lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700130testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700131run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000132build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700133
Alex Light91de25f2015-10-28 17:00:06 -0700134quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000135debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700136prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700137target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700138dev_mode="no"
139update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700140debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000141relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800142runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700143usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700144build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700145suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700146trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700147trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700148basic_verify="false"
149gc_verify="false"
150gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700151jvmti_trace_stress="false"
Alex Light43e935d2017-06-19 15:40:40 -0700152jvmti_field_stress="false"
Alex Lightc38c3692017-06-27 15:45:14 -0700153jvmti_step_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700154jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700155strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700156always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700157never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700158have_image="yes"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800159multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000160android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700161bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800162suspend_timeout="500000"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000163image_suffix=""
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100164run_optimizing="false"
jeffhao5d1ac922011-09-29 17:41:15 -0700165
166while true; do
167 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700168 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700169 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100170 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700171 shift
Alex Light91de25f2015-10-28 17:00:06 -0700172 elif [ "x$1" = "x--quiet" ]; then
173 quiet="yes"
174 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700175 elif [ "x$1" = "x--use-java-home" ]; then
176 if [ -n "${JAVA_HOME}" ]; then
177 export JAVA="${JAVA_HOME}/bin/java"
178 export JAVAC="${JAVA_HOME}/bin/javac -g"
179 else
180 echo "Passed --use-java-home without JAVA_HOME variable set!"
181 usage="yes"
182 fi
183 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800184 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700185 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800186 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800187 runtime="jvm"
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700188 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700189 NEED_DEX="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100190 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700191 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800192 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700193 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700194 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700195 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700196 shift
197 elif [ "x$1" = "x--dalvik" ]; then
198 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800199 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700200 shift
Alex Light03a112d2014-08-25 13:25:56 -0700201 elif [ "x$1" = "x--no-image" ]; then
202 have_image="no"
203 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800204 elif [ "x$1" = "x--multi-image" ]; then
205 multi_image_suffix="-multi"
206 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700207 elif [ "x$1" = "x--pic-test" ]; then
208 run_args="${run_args} --pic-test"
209 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700210 elif [ "x$1" = "x--relocate" ]; then
211 relocate="yes"
212 shift
213 elif [ "x$1" = "x--no-relocate" ]; then
214 relocate="no"
215 shift
216 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100217 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700218 prebuild_mode="yes"
219 shift;
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800220 elif [ "x$1" = "x--compact-dex-level" ]; then
221 option="$1"
222 shift
223 run_args="${run_args} $option $1"
224 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700225 elif [ "x$1" = "x--strip-dex" ]; then
226 run_args="${run_args} --strip-dex"
227 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000228 elif [ "x$1" = "x--debuggable" ]; then
229 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000230 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000231 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700232 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100233 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700234 prebuild_mode="no"
235 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700236 elif [ "x$1" = "x--gcverify" ]; then
237 basic_verify="true"
238 gc_verify="true"
239 shift
240 elif [ "x$1" = "x--gcstress" ]; then
241 basic_verify="true"
242 gc_stress="true"
243 shift
Alex Lightc38c3692017-06-27 15:45:14 -0700244 elif [ "x$1" = "x--jvmti-step-stress" ]; then
245 jvmti_step_stress="true"
246 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700247 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
248 jvmti_redefine_stress="true"
249 shift
Alex Light43e935d2017-06-19 15:40:40 -0700250 elif [ "x$1" = "x--jvmti-field-stress" ]; then
251 jvmti_field_stress="true"
252 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700253 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
254 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700255 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800256 elif [ "x$1" = "x--suspend-timeout" ]; then
257 shift
258 suspend_timeout="$1"
259 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700260 elif [ "x$1" = "x--image" ]; then
261 shift
262 image="$1"
263 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700264 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000265 elif [ "x$1" = "x-Xcompiler-option" ]; then
266 shift
267 option="$1"
268 run_args="${run_args} -Xcompiler-option $option"
269 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000270 elif [ "x$1" = "x--build-option" ]; then
271 shift
272 option="$1"
273 build_args="${build_args} $option"
274 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700275 elif [ "x$1" = "x--runtime-option" ]; then
276 shift
277 option="$1"
278 run_args="${run_args} --runtime-option $option"
279 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700280 elif [ "x$1" = "x--gdb-arg" ]; then
281 shift
282 gdb_arg="$1"
283 run_args="${run_args} --gdb-arg $gdb_arg"
284 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700285 elif [ "x$1" = "x--debug" ]; then
286 run_args="${run_args} --debug"
287 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700288 elif [ "x$1" = "x--debug-wrap-agent" ]; then
289 run_args="${run_args} --debug-wrap-agent"
290 shift
Alex Light0e151e72017-10-25 10:50:35 -0700291 elif [ "x$1" = "x--with-agent" ]; then
292 shift
293 option="$1"
294 run_args="${run_args} --with-agent $1"
295 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700296 elif [ "x$1" = "x--debug-agent" ]; then
297 shift
298 option="$1"
299 run_args="${run_args} --debug-agent $1"
300 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700301 elif [ "x$1" = "x--gdb" ]; then
302 run_args="${run_args} --gdb"
303 dev_mode="yes"
304 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700305 elif [ "x$1" = "x--strace" ]; then
306 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700307 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700308 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700309 elif [ "x$1" = "x--zygote" ]; then
310 run_args="${run_args} --zygote"
311 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800312 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000313 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700314 image_suffix="-interpreter"
315 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800316 elif [ "x$1" = "x--jit" ]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100317 run_args="${run_args} --jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000318 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800319 shift
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100320 elif [ "x$1" = "x--baseline" ]; then
321 run_args="${run_args} --baseline"
322 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700323 elif [ "x$1" = "x--optimizing" ]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100324 run_optimizing="true"
jeffhao0dff3f42012-11-20 15:13:43 -0800325 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700326 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700327 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700328 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700329 elif [ "x$1" = "x--verify-soft-fail" ]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100330 run_args="${run_args} --verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700331 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700332 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700333 elif [ "x$1" = "x--no-optimize" ]; then
334 run_args="${run_args} --no-optimize"
335 shift
336 elif [ "x$1" = "x--no-precise" ]; then
337 run_args="${run_args} --no-precise"
338 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700339 elif [ "x$1" = "x--invoke-with" ]; then
340 shift
341 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700342 if [ "x$what" = "x" ]; then
343 echo "$0 missing argument to --invoke-with" 1>&2
344 usage="yes"
345 break
346 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700347 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700348 shift
349 elif [ "x$1" = "x--dev" ]; then
350 run_args="${run_args} --dev"
351 dev_mode="yes"
352 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700353 elif [ "x$1" = "x--build-only" ]; then
354 build_only="yes"
355 shift
356 elif [ "x$1" = "x--output-path" ]; then
357 shift
358 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700359 if [ "x$tmp_dir" = "x" ]; then
360 echo "$0 missing argument to --output-path" 1>&2
361 usage="yes"
362 break
363 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700364 shift
Roland Levillain76cfe612017-10-30 13:14:28 +0000365 elif [ "x$1" = "x--chroot" ]; then
366 shift
367 if [ "x$1" = "x" ]; then
368 echo "$0 missing argument to --chroot" 1>&2
369 usage="yes"
370 break
371 fi
372 chroot="$1"
373 run_args="${run_args} --chroot $1"
374 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000375 elif [ "x$1" = "x--android-root" ]; then
376 shift
377 if [ "x$1" = "x" ]; then
378 echo "$0 missing argument to --android-root" 1>&2
379 usage="yes"
380 break
381 fi
382 android_root="$1"
383 run_args="${run_args} --android-root $1"
384 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700385 elif [ "x$1" = "x--update" ]; then
386 update_mode="yes"
387 shift
388 elif [ "x$1" = "x--help" ]; then
389 usage="yes"
390 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700391 elif [ "x$1" = "x--64" ]; then
392 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700393 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700394 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200395 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700396 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200397 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700398 elif [ "x$1" = "x--stream" ]; then
399 trace_stream="true"
400 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700401 elif [ "x$1" = "x--always-clean" ]; then
402 always_clean="yes"
403 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700404 elif [ "x$1" = "x--never-clean" ]; then
405 never_clean="yes"
406 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800407 elif [ "x$1" = "x--dex2oat-swap" ]; then
408 run_args="${run_args} --dex2oat-swap"
409 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700410 elif [ "x$1" = "x--instruction-set-features" ]; then
411 shift
412 run_args="${run_args} --instruction-set-features $1"
413 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700414 elif [ "x$1" = "x--bisection-search" ]; then
415 bisection_search="yes"
416 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000417 elif [ "x$1" = "x--vdex" ]; then
418 run_args="${run_args} --vdex"
419 shift
Nicolas Geoffraybaeaa9b2018-01-26 14:31:17 +0000420 elif [ "x$1" = "x--dm" ]; then
421 run_args="${run_args} --dm"
422 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000423 elif [ "x$1" = "x--vdex-filter" ]; then
424 shift
425 filter=$1
426 run_args="${run_args} --vdex-filter $filter"
427 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700428 elif [ "x$1" = "x--random-profile" ]; then
429 run_args="${run_args} --random-profile"
430 shift
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700431 elif [ "x$1" = "x--dex2oat-jobs" ]; then
432 shift
433 run_args="${run_args} -Xcompiler-option -j$1"
434 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700435 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700436 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700437 usage="yes"
438 break
439 else
440 break
441 fi
442done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700443
Orion Hodson6aa4e0d2018-05-25 09:39:16 +0100444if [ "$usage" = "no" -a "x$1" = "x" ]; then
445 echo "missing test to run" 1>&2
446 usage="yes"
447fi
448
Roland Levillain76cfe612017-10-30 13:14:28 +0000449# The DEX_LOCATION with the chroot prefix, if any.
450chroot_dex_location="$chroot$DEX_LOCATION"
451
Alex Light91de25f2015-10-28 17:00:06 -0700452# Allocate file descriptor real_stderr and redirect it to the shell's error
453# output (fd 2).
454if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
455 exec {real_stderr}>&2
456else
457 # In bash before version 4.1 we need to do a manual search for free file
458 # descriptors.
459 FD=3
460 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
461 real_stderr=$FD
462 eval "exec ${real_stderr}>&2"
463fi
464if [ "$quiet" = "yes" ]; then
465 # Force the default standard output and error to go to /dev/null so we will
466 # not print them.
467 exec 1>/dev/null
468 exec 2>/dev/null
469fi
470
471function err_echo() {
472 echo "$@" 1>&${real_stderr}
473}
474
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700475# tmp_dir may be relative, resolve.
476#
477# Cannot use realpath, as it does not exist on Mac.
Roland Levillain76cfe612017-10-30 13:14:28 +0000478# Cannot use a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700479# Cannot use readlink -m, as it does not exist on Mac.
480# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700481noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700482tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700483mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700484
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800485# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000486if [ ! "$runtime" = "jvm" ]; then
487 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
488fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800489
Alex Lighte7873ec2014-08-12 09:53:50 -0700490if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800491 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
492 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700493fi
494if [ "$gc_verify" = "true" ]; then
495 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
496fi
497if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700498 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700499fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700500if [ "$jvmti_redefine_stress" = "true" ]; then
501 run_args="${run_args} --no-app-image --jvmti-redefine-stress"
502fi
Alex Lightc38c3692017-06-27 15:45:14 -0700503if [ "$jvmti_step_stress" = "true" ]; then
504 run_args="${run_args} --no-app-image --jvmti-step-stress"
505fi
Alex Light43e935d2017-06-19 15:40:40 -0700506if [ "$jvmti_field_stress" = "true" ]; then
507 run_args="${run_args} --no-app-image --jvmti-field-stress"
508fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700509if [ "$jvmti_trace_stress" = "true" ]; then
510 run_args="${run_args} --no-app-image --jvmti-trace-stress"
Alex Light8f2c6d42017-04-10 16:27:35 -0700511fi
Jeff Hao85139a32014-07-23 11:52:52 -0700512if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700513 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
514 if [ "$trace_stream" = "true" ]; then
515 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
516 # the ability to analyze the file and just write to /dev/null.
517 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
518 # Enable streaming mode.
519 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
520 else
521 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
522 fi
523elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700524 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700525 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700526fi
527
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700528# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000529# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100530function guess_target_arch_name() {
Andreas Gamped0566d42018-06-06 09:54:34 -0700531 # Check whether this is a device with native bridge. Currently this is hardcoded
532 # to x86 + arm.
533 x86_arm=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | sort | grep -E '^(arm|x86)$'`
534 # Collapse line-breaks into spaces
535 x86_arm=$(echo $x86_arm)
536 if [ "x$x86_arm" = "xarm x86" ] ; then
537 err_echo "Native-bridge configuration detected."
538 # We only support the main arch for tests.
539 if [ "x${suffix64}" = "x64" ]; then
540 target_arch_name=""
541 else
542 target_arch_name=x86
543 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700544 else
Andreas Gamped0566d42018-06-06 09:54:34 -0700545 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
546 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
547 if [ "x${suffix64}" = "x64" ]; then
548 target_arch_name=${grep64bit}
549 else
550 target_arch_name=${grep32bit}
551 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700552 fi
553}
554
David Brazdil853a4c32015-09-28 16:15:50 +0100555function guess_host_arch_name() {
556 if [ "x${suffix64}" = "x64" ]; then
557 host_arch_name="x86_64"
558 else
559 host_arch_name="x86"
560 fi
561}
562
Alex Lighta59dd802014-07-02 16:28:08 -0700563if [ "$target_mode" = "no" ]; then
564 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700565 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700566 err_echo "--prebuild with --jvm is unsupported"
Roland Levillain76cfe612017-10-30 13:14:28 +0000567 exit 1
568 fi
569 else
570 # ART/Dalvik host mode.
571 if [ -n "$chroot" ]; then
572 err_echo "--chroot with --host is unsupported"
573 exit 1
Alex Lighta59dd802014-07-02 16:28:08 -0700574 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700575 fi
576fi
577
Jeff Hao201803f2013-11-20 18:11:39 -0800578if [ ! "$runtime" = "jvm" ]; then
579 run_args="${run_args} --lib $lib"
580fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700581
Jeff Hao201803f2013-11-20 18:11:39 -0800582if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700583 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000584 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800585 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700586 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700587 else
588 true # defaults to using target BOOTCLASSPATH
589 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800590elif [ "$runtime" = "art" ]; then
591 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100592 guess_host_arch_name
Richard Uhlerbb00f812017-02-16 14:21:10 +0000593 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700594 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800595 else
David Brazdil853a4c32015-09-28 16:15:50 +0100596 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800597 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Richard Uhlerbb00f812017-02-16 14:21:10 +0000598 run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800599 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700600 if [ "$relocate" = "yes" ]; then
601 run_args="${run_args} --relocate"
602 else
603 run_args="${run_args} --no-relocate"
604 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700605elif [ "$runtime" = "jvm" ]; then
606 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800607 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700608fi
609
Alex Light03a112d2014-08-25 13:25:56 -0700610if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700611 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700612 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700613 exit 1
614 fi
Alex Light03a112d2014-08-25 13:25:56 -0700615 run_args="${run_args} --no-image"
616fi
617
jeffhao5d1ac922011-09-29 17:41:15 -0700618if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700619 err_echo "--dev and --update are mutually exclusive"
620 usage="yes"
621fi
622
623if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
624 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700625 usage="yes"
626fi
627
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700628if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
629 err_echo "--bisection-search and --prebuild are mutually exclusive"
630 usage="yes"
631fi
632
Roland Levillain76cfe612017-10-30 13:14:28 +0000633# TODO: Chroot-based bisection search is not supported yet (see below); implement it.
634if [ "$bisection_search" = "yes" -a -n "$chroot" ]; then
635 err_echo "--chroot with --bisection-search is unsupported"
636 exit 1
637fi
638
jeffhao5d1ac922011-09-29 17:41:15 -0700639if [ "$usage" = "no" ]; then
640 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
641 test_dir=`basename "$oldwd"`
642 else
643 test_dir="$1"
644 fi
645
646 if [ '!' -d "$test_dir" ]; then
647 td2=`echo ${test_dir}-*`
648 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700649 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700650 usage="yes"
651 fi
652 test_dir="$td2"
653 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700654 # Shift to get rid of the test name argument. The rest of the arguments
655 # will get passed to the test run.
656 shift
657fi
658
659if [ "$usage" = "yes" ]; then
660 prog=`basename $prog`
661 (
662 echo "usage:"
663 echo " $prog --help Print this message."
664 echo " $prog [options] [test-name] Run test normally."
665 echo " $prog --dev [options] [test-name] Development mode" \
666 "(dumps to stdout)."
667 echo " $prog --update [options] [test-name] Update mode" \
668 "(replaces expected.txt)."
669 echo ' Omitting the test name or specifying "-" will use the' \
670 "current directory."
671 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000672 echo " -O Run non-debug rather than debug build (off by default)."
673 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000674 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000675 echo " --runtime-option Pass an option to the runtime."
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800676 echo " --compact-dex-level Specify a compact dex level to the compiler."
Alex Lightc281ba52017-10-11 11:35:55 -0700677 echo " --debug Wait for the default debugger to attach."
678 echo " --debug-agent <agent-path>"
679 echo " Wait for the given debugger agent to attach. Currently"
680 echo " only supported on host."
681 echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props"
682 echo " to load the debugger agent specified by --debug-agent."
Alex Light0e151e72017-10-25 10:50:35 -0700683 echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000684 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000685 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700686 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000687 echo " --build-only Build test files only (off by default)."
688 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800689 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000690 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000691 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700692 echo " --verify-soft-fail Force soft fail verification (off by default)."
693 echo " Verification is enabled if neither --no-verify"
694 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000695 echo " --no-optimize Turn off optimization (on by default)."
696 echo " --no-precise Turn off precise GC (on by default)."
697 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700698 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000699 echo " other runtime options are ignored."
700 echo " --no-dex2oat Run as though dex2oat was failing."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000701 echo " --prebuild Run dex2oat on the files before starting test. (default)"
702 echo " --no-prebuild Do not run dex2oat on the files before starting"
703 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700704 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000705 echo " --relocate Force the use of relocating in the test, making"
706 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000707 echo " address before running."
708 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700709 echo " --image Run the test using a precompiled boot image. (default)"
710 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000711 echo " --host Use the host-mode virtual machine."
712 echo " --invoke-with Pass --invoke-with option to runtime."
713 echo " --dalvik Use Dalvik (off by default)."
714 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700715 echo " --use-java-home Use the JAVA_HOME environment variable"
716 echo " to find the java compiler and runtime"
717 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000718 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700719 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000720 echo " --64 Run the test in 64-bit mode"
721 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700722 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700723 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000724 echo " --gcstress Run with gc stress testing"
725 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700726 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
Alex Lightc38c3692017-06-27 15:45:14 -0700727 echo " --jvmti-step-stress Run with jvmti single step stress testing"
Alex Lightb7edcda2017-04-27 13:20:31 -0700728 echo " --jvmti-redefine-stress"
729 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000730 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700731 echo " --never-clean Keep the test files even if the test succeeds."
Roland Levillain76cfe612017-10-30 13:14:28 +0000732 echo " --chroot [newroot] Run with root directory set to newroot."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000733 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000734 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700735 echo " --instruction-set-features [string]"
736 echo " Set instruction-set-features for compilation."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800737 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
738 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700739 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700740 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700741 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000742 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800743 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700744 echo " --dex2oat-jobs Number of dex2oat jobs."
Alex Light91de25f2015-10-28 17:00:06 -0700745 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700746 exit 1
747fi
748
749cd "$test_dir"
750test_dir=`pwd`
751
752td_info="${test_dir}/${info}"
753td_expected="${test_dir}/${expected}"
754
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700755if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700756 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700757 exit 1
758fi
759
760if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700761 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700762 exit 1
763fi
764
765# copy the test to a temp dir and run it
766
Elliott Hughes510c8782011-10-06 10:57:34 -0700767echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700768
769rm -rf "$tmp_dir"
Nicolas Geoffray202b6172018-10-10 07:47:58 +0000770cp -Rp "$test_dir" "$tmp_dir"
jeffhao5d1ac922011-09-29 17:41:15 -0700771cd "$tmp_dir"
772
773if [ '!' -r "$build" ]; then
774 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800775else
776 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700777fi
778
779if [ '!' -r "$run" ]; then
780 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800781else
782 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700783fi
784
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700785if [ '!' -r "$check_cmd" ]; then
786 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800787else
788 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700789fi
790
jeffhao5d1ac922011-09-29 17:41:15 -0700791chmod 755 "$build"
792chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700793chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700794
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700795export TEST_NAME=`basename ${test_dir}`
796
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000797# Tests named '<number>-checker-*' will also have their CFGs verified with
798# Checker when compiled with Optimizing on host.
799if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100800 if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$run_optimizing" = "true" ]; then
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000801 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
802 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
803 run_checker="yes"
804
805 if [ "$target_mode" = "no" ]; then
806 cfg_output_dir="$tmp_dir"
807 checker_args="--arch=${host_arch_name^^}"
808 else
809 cfg_output_dir="$DEX_LOCATION"
810 checker_args="--arch=${target_arch_name^^}"
811 fi
812
813 if [ "$debuggable" = "yes" ]; then
814 checker_args="$checker_args --debuggable"
815 fi
816
817 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
818 -Xcompiler-option -j1"
819 fi
820 fi
821fi
822
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100823run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700824
Richard Uhler020c0f32017-03-14 16:23:17 +0000825# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
826# ART output to approximately 128MB. This should be more than sufficient
827# for any test while still catching cases of runaway output.
828# Set a hard limit to encourage ART developers to increase the ulimit here if
829# needed to support a test case rather than resetting the limit in the run
830# script for the particular test in question.
Orion Hodsonbd328d32017-03-24 11:24:10 +0000831if ! ulimit -f 128000; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000832 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700833fi
834
Igor Murashkin2de6e082018-02-28 15:25:23 -0800835# Tell the build script which mode (target, host, jvm) we are building for
836# to determine the bootclasspath at build time.
Igor Murashkin2a337752017-06-16 14:34:40 +0000837if [[ "$target_mode" == "yes" ]]; then
838 build_args="$build_args --target"
839else
Igor Murashkin2de6e082018-02-28 15:25:23 -0800840 if [[ $runtime == "jvm" ]]; then
841 build_args="$build_args --jvm"
842 else
843 build_args="$build_args --host"
844 fi
Igor Murashkin2a337752017-06-16 14:34:40 +0000845fi
846
847if [[ "$dev_mode" == "yes" ]]; then
848 build_args="$build_args --dev"
849fi
850
jeffhao5d1ac922011-09-29 17:41:15 -0700851good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000852good_build="yes"
853good_run="yes"
Alex Light77fee872017-09-05 14:51:49 -0700854export TEST_RUNTIME="${runtime}"
jeffhao5d1ac922011-09-29 17:41:15 -0700855if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000856 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700857 build_exit="$?"
858 echo "build exit status: $build_exit" 1>&2
859 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800860 echo "${test_dir}: running..." 1>&2
861 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700862 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000863
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800864 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000865 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100866 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000867 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100868 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100869 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000870 checker_exit="$?"
871 if [ "$checker_exit" = "0" ]; then
872 good="yes"
873 fi
Alex Light91de25f2015-10-28 17:00:06 -0700874 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000875 else
876 good="yes"
877 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800878 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000879 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700880 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700881elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000882 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700883 build_exit="$?"
884 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800885 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700886 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000887 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100888 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000889 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100890 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100891 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000892 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700893 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
894 good="yes"
895 else
Alex Light91de25f2015-10-28 17:00:06 -0700896 cat "$build_output" 1>&${real_stderr} 1>&2
897 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700898 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700899elif [ "$build_only" = "yes" ]; then
900 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000901 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700902 build_exit="$?"
903 if [ "$build_exit" '!=' '0' ]; then
904 cp "$build_output" "$output"
905 echo "build exit status: $build_exit" >>"$output"
906 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
907 if [ "$?" '!=' "0" ]; then
908 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700909 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700910 fi
911 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700912 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700913 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700914 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700915else
David Brazdil4846d132015-01-15 19:07:08 +0000916 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700917 build_exit="$?"
918 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800919 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700920 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000921 run_exit="$?"
922 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700923 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000924 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000925 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100926 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000927 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100928 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100929 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000930 checker_exit="$?"
931 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700932 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000933 good_run="no"
934 else
935 good_run="yes"
936 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000937 else
938 good_run="yes"
939 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700940 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000941 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700942 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700943 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
944 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700945 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700946 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700947 max_name_length=$(getconf NAME_MAX ${tmp_dir})
948 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
949 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700950 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700951 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700952 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700953 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000954 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
955 # output == expected
956 good="yes"
957 echo "${test_dir}: succeeded!" 1>&2
958 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700959 fi
960fi
961
jeffhao5d1ac922011-09-29 17:41:15 -0700962(
Alex Lightbfac14a2014-07-30 09:41:21 -0700963 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700964 echo "${test_dir}: FAILED!"
965 echo ' '
966 echo '#################### info'
967 cat "${td_info}" | sed 's/^/# /g'
968 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700969 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700970 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700971 if [ "$strace" = "yes" ]; then
972 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700973 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700974 echo '####################'
975 fi
Andreas Gampee79ca192017-07-31 10:30:16 -0700976 if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then
977 # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The
978 # tools used by the given ABI work for both x86 and x86-64.
979 echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000
980 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700981 echo ' '
982 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700983
Alex Light91de25f2015-10-28 17:00:06 -0700984) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700985
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700986# Attempt bisection only if the test failed.
Roland Levillain76cfe612017-10-30 13:14:28 +0000987# TODO: Implement support for chroot-based bisection search.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700988if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
989 # Bisecting works by skipping different optimization passes which breaks checker assertions.
990 if [ "$run_checker" == "yes" ]; then
991 echo "${test_dir}: not bisecting, checker test." 1>&2
992 else
993 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700994 echo "${test_dir}: bisecting..." 1>&2
995 cwd=`pwd`
996 maybe_device_mode=""
997 raw_cmd=""
998 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000999 # Produce cmdline.sh in $chroot_dex_location. "$@" is passed as a runtime option
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001000 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
1001 # to exec in order to preserve pid when calling dalvikvm. This is required
1002 # for bisection search to correctly retrieve logs from device.
1003 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
Roland Levillain76cfe612017-10-30 13:14:28 +00001004 adb shell chmod u+x "$chroot_dex_location/cmdline.sh"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001005 maybe_device_mode="--device"
1006 raw_cmd="$DEX_LOCATION/cmdline.sh"
1007 else
1008 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
1009 fi
Roland Levillain76cfe612017-10-30 13:14:28 +00001010 # TODO: Pass a `--chroot` option to the bisection_search.py script and use it there.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001011 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
1012 $maybe_device_mode \
1013 --raw-cmd="$raw_cmd" \
1014 --check-script="$cwd/check" \
1015 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -07001016 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001017 --timeout=300
1018 fi
1019fi
1020
Alex Lightbfac14a2014-07-30 09:41:21 -07001021# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -07001022if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -07001023 cd "$oldwd"
1024 rm -rf "$tmp_dir"
1025 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001026 adb shell rm -rf $chroot_dex_location
Alex Lightbfac14a2014-07-30 09:41:21 -07001027 fi
1028 if [ "$good" = "yes" ]; then
1029 exit 0
1030 fi
1031fi
1032
1033
1034(
1035 if [ "$always_clean" = "yes" ]; then
1036 echo "${TEST_NAME} files deleted from host "
1037 if [ "$target_mode" == "yes" ]; then
1038 echo "and from target"
1039 fi
1040 else
1041 echo "${TEST_NAME} files left in ${tmp_dir} on host"
1042 if [ "$target_mode" == "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001043 echo "and in ${chroot_dex_location} on target"
Alex Lightbfac14a2014-07-30 09:41:21 -07001044 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -07001045 fi
1046
Alex Light91de25f2015-10-28 17:00:06 -07001047) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001048
Alex Light6a870fa2016-05-31 16:36:19 -07001049if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1050 exit 0
1051else
1052 exit 1
1053fi